/***************************************************************************************************
LoadingOverlay - A flexible loading overlay jQuery plugin
    Author          : Gaspare Sganga
    Version         : 2.1.0
    License         : MIT
    Documentation   : https://gasparesganga.com/labs/jquery-loading-overlay/
***************************************************************************************************/
!function(e){"function"==typeof define&&define.amd?define(["jquery"],e):"object"==typeof module&&module.exports?e(require("jquery")):e(jQuery)}(function(e,s){"use strict";var a={background:"rgba(255, 255, 255, 0.8)",backgroundClass:"",image:"<svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 1000 1000'><circle r='80' cx='500' cy='90'/><circle r='80' cx='500' cy='910'/><circle r='80' cx='90' cy='500'/><circle r='80' cx='910' cy='500'/><circle r='80' cx='212' cy='212'/><circle r='80' cx='788' cy='212'/><circle r='80' cx='212' cy='788'/><circle r='80' cx='788' cy='788'/></svg>",imageAnimation:"2000ms rotate_right",imageAutoResize:!0,imageResizeFactor:1,imageColor:"#202020",imageClass:"",imageOrder:1,fontawesome:"",fontawesomeAnimation:"",fontawesomeAutoResize:!0,fontawesomeResizeFactor:1,fontawesomeColor:"#202020",fontawesomeOrder:2,custom:"",customAnimation:"",customAutoResize:!0,customResizeFactor:1,customOrder:3,text:"",textAnimation:"",textAutoResize:!0,textResizeFactor:.5,textColor:"#202020",textClass:"",textOrder:4,progress:!1,progressAutoResize:!0,progressResizeFactor:.25,progressColor:"#a0a0a0",progressClass:"",progressOrder:5,progressFixedPosition:"",progressSpeed:200,progressMin:0,progressMax:100,size:50,maxSize:120,minSize:20,direction:"column",fade:!0,resizeInterval:50,zIndex:2147483647},o={overlay:{"box-sizing":"border-box",position:"relative",display:"flex","flex-wrap":"nowrap","align-items":"center","justify-content":"space-around"},element:{"box-sizing":"border-box",overflow:"visible",flex:"0 0 auto",display:"flex","justify-content":"center","align-items":"center"},element_svg:{width:"100%",height:"100%"},progress_fixed:{position:"absolute",left:"0",width:"100%"},progress_wrapper:{position:"absolute",top:"0",left:"0",width:"100%",height:"100%"},progress_bar:{position:"absolute",left:"0"}},t={count:0,overlay:s,settings:s,wholePage:s,resizeIntervalId:s,text:s,progress:s},r={animations:["rotate_right","rotate_left","fadein","pulse"],progressPosition:["top","bottom"]},i={animations:{name:"rotate_right",time:"2000ms"},fade:[400,200]};function n(s,a){s=e(s),a.size=x(a.size),a.maxSize=parseInt(a.maxSize,10)||0,a.minSize=parseInt(a.minSize,10)||0,a.resizeInterval=parseInt(a.resizeInterval,10)||0;var r=s.data("loadingoverlay");if(void 0===r){if((r=e.extend({},t)).wholePage=s.is("body"),s.data("loadingoverlay",r),r.overlay=e("<div>",{class:"loadingoverlay"}).css(o.overlay).css("flex-direction","row"===a.direction.toLowerCase()?"row":"column"),a.backgroundClass?r.overlay.addClass(a.backgroundClass):r.overlay.css("background",a.background),r.wholePage&&r.overlay.css({position:"fixed",top:0,left:0,width:"100%",height:"100%"}),void 0!==a.zIndex&&r.overlay.css("z-index",a.zIndex),a.image){e.isArray(a.imageColor)?0===a.imageColor.length?a.imageColor=!1:1===a.imageColor.length?a.imageColor={fill:a.imageColor[0]}:a.imageColor={fill:a.imageColor[0],stroke:a.imageColor[1]}:a.imageColor&&(a.imageColor={fill:a.imageColor});var n=f(r.overlay,a.imageOrder,a.imageAutoResize,a.imageResizeFactor,a.imageAnimation);"<svg"===a.image.slice(0,4).toLowerCase()&&"</svg>"===a.image.slice(-6).toLowerCase()?(n.append(a.image),n.children().css(o.element_svg),!a.imageClass&&a.imageColor&&n.find("*").css(a.imageColor)):".svg"===a.image.slice(-4).toLowerCase()||"data:image/svg"===a.image.slice(0,14).toLowerCase()?n.load(a.image,function(){n.children().css(o.element_svg),!a.imageClass&&a.imageColor&&n.find("*").css(a.imageColor)}):n.css({"background-image":"url("+a.image+")","background-position":"center","background-repeat":"no-repeat","background-size":"cover"}),a.imageClass&&n.addClass(a.imageClass)}if(a.fontawesome){n=f(r.overlay,a.fontawesomeOrder,a.fontawesomeAutoResize,a.fontawesomeResizeFactor,a.fontawesomeAnimation).addClass("loadingoverlay_fa");e("<div>",{class:a.fontawesome}).appendTo(n),a.fontawesomeColor&&n.css("color",a.fontawesomeColor)}if(a.custom)n=f(r.overlay,a.customOrder,a.customAutoResize,a.customResizeFactor,a.customAnimation).append(a.custom);if(a.text&&(r.text=f(r.overlay,a.textOrder,a.textAutoResize,a.textResizeFactor,a.textAnimation).addClass("loadingoverlay_text").text(a.text),a.textClass?r.text.addClass(a.textClass):a.textColor&&r.text.css("color",a.textColor)),a.progress){n=f(r.overlay,a.progressOrder,a.progressAutoResize,a.progressResizeFactor,!1).addClass("loadingoverlay_progress");var l=e("<div>").css(o.progress_wrapper).appendTo(n);r.progress={bar:e("<div>").css(o.progress_bar).appendTo(l),fixed:!1,margin:0,min:parseFloat(a.progressMin),max:parseFloat(a.progressMax),speed:parseInt(a.progressSpeed,10)};var g=(a.progressFixedPosition+"").replace(/\s\s+/g," ").toLowerCase().split(" ");2===g.length&&v(g[0])?(r.progress.fixed=g[0],r.progress.margin=x(g[1])):2===g.length&&v(g[1])?(r.progress.fixed=g[1],r.progress.margin=x(g[0])):1===g.length&&v(g[0])&&(r.progress.fixed=g[0],r.progress.margin=0),"top"===r.progress.fixed?n.css(o.progress_fixed).css("top",r.progress.margin?r.progress.margin.value+(r.progress.margin.fixed?r.progress.margin.units:"%"):0):"bottom"===r.progress.fixed&&n.css(o.progress_fixed).css("top","auto"),a.progressClass?r.progress.bar.addClass(a.progressClass):a.progressColor&&r.progress.bar.css("background",a.progressColor)}a.fade?!0===a.fade?a.fade=i.fade:"string"==typeof a.fade||"number"==typeof a.fade?a.fade=[a.fade,a.fade]:e.isArray(a.fade)&&a.fade.length<2&&(a.fade=[a.fade[0],a.fade[0]]):a.fade=[0,0],a.fade=[parseInt(a.fade[0],10),parseInt(a.fade[1],10)],r.settings=a,r.overlay.fadeTo(0,.01).appendTo("body"),m(s,!0),a.resizeInterval>0&&(r.resizeIntervalId=setInterval(function(){m(s,!1)},a.resizeInterval)),r.overlay.fadeTo(a.fade[0],1)}r.count++}function l(s,a){var o=(s=e(s)).data("loadingoverlay");void 0!==o&&(o.count--,(a||o.count<=0)&&(o.resizeIntervalId&&clearInterval(o.resizeIntervalId),o.overlay.fadeOut(o.settings.fade[1],function(){e(this).remove()}),s.removeData("loadingoverlay")))}function g(s){m(e(s),!0)}function d(s,a){var o=(s=e(s)).data("loadingoverlay");void 0!==o&&o.text&&(!1===a?o.text.hide():o.text.show().text(a))}function c(s,a){var o=(s=e(s)).data("loadingoverlay");if(void 0!==o&&o.progress)if(!1===a)o.progress.bar.hide();else{var t=100*((parseFloat(a)||0)-o.progress.min)/(o.progress.max-o.progress.min);t<0&&(t=0),t>100&&(t=100),o.progress.bar.show().animate({width:t+"%"},o.progress.speed)}}function m(s,a){var o=s.data("loadingoverlay");if(!o.wholePage){var t="fixed"===s.css("position"),r=t?s[0].getBoundingClientRect():s.offset();o.overlay.css({position:t?"fixed":"absolute",top:r.top+parseInt(s.css("border-top-width"),10),left:r.left+parseInt(s.css("border-left-width"),10),width:s.innerWidth(),height:s.innerHeight()})}if(o.settings.size){var i=o.wholePage?e(window):s,n=o.settings.size.value;o.settings.size.fixed||(n=Math.min(i.innerWidth(),i.innerHeight())*n/100,o.settings.maxSize&&n>o.settings.maxSize&&(n=o.settings.maxSize),o.settings.minSize&&n<o.settings.minSize&&(n=o.settings.minSize)),o.overlay.children(".loadingoverlay_element").each(function(){var t=e(this);if(a||t.data("loadingoverlay_autoresize")){var r=t.data("loadingoverlay_resizefactor");if(t.hasClass("loadingoverlay_fa")||t.hasClass("loadingoverlay_text"))t.css("font-size",n*r+o.settings.size.units);else if(t.hasClass("loadingoverlay_progress")){var i=s.data("loadingoverlay").progress;i.bar.css("height",n*r+o.settings.size.units),i.fixed?"bottom"===i.fixed&&t.css("bottom",i.margin?i.margin.value+(i.margin.fixed?i.margin.units:"%"):0).css("bottom","+="+n*r+o.settings.size.units):i.bar.css("top",t.position().top).css("top","-="+n*r*.5+o.settings.size.units)}else t.css({width:n*r+o.settings.size.units,height:n*r+o.settings.size.units})}})}}function f(s,a,t,r,n){var l=e("<div>",{class:"loadingoverlay_element",css:{order:a}}).css(o.element).data({loadingoverlay_autoresize:t,loadingoverlay_resizefactor:r}).appendTo(s);if(!0===n&&(n=i.animations.time+" "+i.animations.name),"string"==typeof n){var g,d,c=n.replace(/\s\s+/g," ").toLowerCase().split(" ");2===c.length&&p(c[0])&&u(c[1])?(g=c[1],d=c[0]):2===c.length&&p(c[1])&&u(c[0])?(g=c[0],d=c[1]):1===c.length&&p(c[0])?(g=i.animations.name,d=c[0]):1===c.length&&u(c[0])&&(g=c[0],d=i.animations.time),l.css({"animation-name":"loadingoverlay_animation__"+g,"animation-duration":d,"animation-timing-function":"linear","animation-iteration-count":"infinite"})}return l}function p(e){return!isNaN(parseFloat(e))&&("s"===e.slice(-1)||"ms"===e.slice(-2))}function u(e){return r.animations.indexOf(e)>-1}function v(e){return r.progressPosition.indexOf(e)>-1}function x(e){return!(!e||e<0)&&("string"==typeof e&&["vmin","vmax"].indexOf(e.slice(-4))>-1?{fixed:!0,units:e.slice(-4),value:e.slice(0,-4)}:"string"==typeof e&&["rem"].indexOf(e.slice(-3))>-1?{fixed:!0,units:e.slice(-3),value:e.slice(0,-3)}:"string"==typeof e&&["px","em","cm","mm","in","pt","pc","vh","vw"].indexOf(e.slice(-2))>-1?{fixed:!0,units:e.slice(-2),value:e.slice(0,-2)}:{fixed:!1,units:"px",value:parseFloat(e)})}e.LoadingOverlaySetup=function(s){e.extend(!0,a,s)},e.LoadingOverlay=function(s,o){switch(s.toLowerCase()){case"show":n("body",e.extend(!0,{},a,o));break;case"hide":l("body",o);break;case"resize":g("body");break;case"text":d("body",o);break;case"progress":c("body",o)}},e.fn.LoadingOverlay=function(s,o){switch(s.toLowerCase()){case"show":var t=e.extend(!0,{},a,o);return this.each(function(){n(this,t)});case"hide":return this.each(function(){l(this,o)});case"resize":return this.each(function(){g(this)});case"text":return this.each(function(){d(this,o)});case"progress":return this.each(function(){c(this,o)})}},e(function(){e("head").append(["<style>","@-webkit-keyframes loadingoverlay_animation__rotate_right {","to {","-webkit-transform : rotate(360deg);","transform : rotate(360deg);","}","}","@keyframes loadingoverlay_animation__rotate_right {","to {","-webkit-transform : rotate(360deg);","transform : rotate(360deg);","}","}","@-webkit-keyframes loadingoverlay_animation__rotate_left {","to {","-webkit-transform : rotate(-360deg);","transform : rotate(-360deg);","}","}","@keyframes loadingoverlay_animation__rotate_left {","to {","-webkit-transform : rotate(-360deg);","transform : rotate(-360deg);","}","}","@-webkit-keyframes loadingoverlay_animation__fadein {","0% {","opacity   : 0;","-webkit-transform : scale(0.1, 0.1);","transform : scale(0.1, 0.1);","}","50% {","opacity   : 1;","}","100% {","opacity   : 0;","-webkit-transform : scale(1, 1);","transform : scale(1, 1);","}","}","@keyframes loadingoverlay_animation__fadein {","0% {","opacity   : 0;","-webkit-transform : scale(0.1, 0.1);","transform : scale(0.1, 0.1);","}","50% {","opacity   : 1;","}","100% {","opacity   : 0;","-webkit-transform : scale(1, 1);","transform : scale(1, 1);","}","}","@-webkit-keyframes loadingoverlay_animation__pulse {","0% {","-webkit-transform : scale(0, 0);","transform : scale(0, 0);","}","50% {","-webkit-transform : scale(1, 1);","transform : scale(1, 1);","}","100% {","-webkit-transform : scale(0, 0);","transform : scale(0, 0);","}","}","@keyframes loadingoverlay_animation__pulse {","0% {","-webkit-transform : scale(0, 0);","transform : scale(0, 0);","}","50% {","-webkit-transform : scale(1, 1);","transform : scale(1, 1);","}","100% {","-webkit-transform : scale(0, 0);","transform : scale(0, 0);","}","}","</style>"].join(" "))})});